--Creates the ALTER INDEX Statements

SET NOCOUNT ON

SELECT distinct
   'ALTER INDEX [' 
   + i.[name] 
   + '] ON [' 
   + s.[name] 
   + '].[' 
   + o.[name] 
   + '] REBUILD WITH (DATA_COMPRESSION=PAGE);'
FROM sys.objects AS o WITH (NOLOCK)
INNER JOIN sys.indexes AS i WITH (NOLOCK)
   ON o.[object_id] = i.[object_id]
INNER JOIN sys.schemas s WITH (NOLOCK)
   ON o.[schema_id] = s.[schema_id]
INNER JOIN sys.dm_db_partition_stats AS ps WITH (NOLOCK)
   ON i.[object_id] = ps.[object_id]
AND ps.[index_id] = i.[index_id]
INNER JOIN sys.partitions AS p WITH (NOLOCK)
   ON i.[object_id] = p.[object_id]
AND p.[index_id] = i.[index_id]
WHERE o.type = 'U' 
AND i.[index_id] >0
AND p.data_compression <> 2
--AND i.Name LIKE '%%'   -- filter by index name
--AND o.Name LIKE '%%'   -- filter by table name
--ORDER BY ps.[reserved_page_count]

SET NOCOUNT OFF

