--Creates the ALTER TABLE Statements

SET NOCOUNT ON

SELECT distinct
   'ALTER TABLE [' 
   + s.[name] 
   + '].[' 
   + o.[name] 
   + '] REBUILD WITH (DATA_COMPRESSION=PAGE);'
   --*
FROM sys.objects AS o WITH (NOLOCK)
INNER JOIN sys.indexes AS i WITH (NOLOCK)
   ON o.[object_id] = i.[object_id] and i.[type] in (0,1)
INNER JOIN sys.schemas AS s WITH (NOLOCK)
   ON o.[schema_id] = s.[schema_id]
INNER JOIN sys.dm_db_partition_stats AS ps WITH (NOLOCK)
   ON i.[object_id] = ps.[object_id]
AND ps.[index_id] = i.[index_id]
INNER JOIN sys.partitions AS p WITH (NOLOCK)
   ON i.[object_id] = p.[object_id]
AND p.[index_id] = i.[index_id]
WHERE o.[type] = 'U'
AND p.data_compression <> 2
--AND s.Name LIKE '%%'   -- filter by table name
--AND o.Name LIKE '%%'   -- filter by schema name
--ORDER BY s.[name], o.[name] --ps.[reserved_page_count]

SET NOCOUNT OFF 