SELECT DISTINCT
	SERVERPROPERTY('servername') [instance]
	,DB_NAME() [database]
	,QUOTENAME(OBJECT_SCHEMA_NAME(sp.object_id)) +'.'+QUOTENAME(Object_name(sp.object_id))[table]
	,ix.name [index_name]
	,sp.data_compression
	,sp.data_compression_desc
FROM sys.partitions SP 
LEFT OUTER JOIN sys.indexes IX 
	ON sp.object_id = ix.object_id 
	and sp.index_id = ix.index_id
WHERE sp.data_compression = 0
 and OBJECT_SCHEMA_NAME(sp.object_id) <> 'sys'
ORDER BY 2; 